// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_outgoing_connections.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const listOutgoingConnections = `-- name: ListOutgoingConnections :many

SELECT
    p.service_peer_id,
    p.service_name,
    p.content_hash,
    c.created_at,
    c.valid_not_after,
    c.valid_not_before,
    c.state,
    p.hash,
    p.public_key_thumbprint,
    $2::text as outway_peer_id,
    p.service_publication_delegator_peer_id,
    p.delegator_peer_id
FROM (
         SELECT  service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, null as delegator_peer_id, public_key_thumbprint
         FROM contracts.grants_service_connection
         WHERE outway_peer_id = $2::text
         UNION DISTINCT
         SELECT service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, delegator_peer_id as delegator_peer_id, public_key_thumbprint
         FROM contracts.grants_delegated_service_connection
         WHERE outway_peer_id = $2::text
     ) AS p
         JOIN contracts.contracts_with_state AS c ON c.hash = p.content_hash
WHERE
    CASE
        when cardinality($3::text[]) = 0 THEN
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state)
        else
            content_hash IN (SELECT hash AS content_hash FROM contracts.contracts_with_state where contracts_with_state.state = ANY ($3::text[]))
        end
  AND
        ($4::timestamp is NULL AND $5::text = '')
        OR (
            $6::text = 'asc'
            AND
            (c.created_at >= $4::timestamp AND (c.created_at > $4::timestamp OR p.hash > $5::text)
        )
        OR (
            $6::text = 'desc'
            AND
            (c.created_at <= $4::timestamp AND (c.created_at < $4::timestamp OR p.hash < $5::text))
        )
    )
ORDER BY
CASE
    WHEN $6::text = 'asc' THEN (c.created_at, p.hash COLLATE "C") END ASC,
CASE
    WHEN $6::text = 'desc' THEN (c.created_at, p.hash COLLATE "C") END DESC
LIMIT $1
`

type ListOutgoingConnectionsParams struct {
	Limit               int32
	SelfPeerID          string
	ContractStates      []string
	PaginationCreatedAt pgtype.Timestamp
	PaginationGrantHash string
	OrderDirection      string
}

type ListOutgoingConnectionsRow struct {
	ServicePeerID                     string
	ServiceName                       string
	ContentHash                       string
	CreatedAt                         pgtype.Timestamptz
	ValidNotAfter                     pgtype.Timestamptz
	ValidNotBefore                    pgtype.Timestamptz
	State                             interface{}
	Hash                              string
	PublicKeyThumbprint               string
	OutwayPeerID                      string
	ServicePublicationDelegatorPeerID pgtype.Text
	DelegatorPeerID                   interface{}
}

// Copyright © VNG Realisatie 2024
// Licensed under the EUPL
// NOTE: unable to use ASC/DESC dynamically so we use a switch case
func (q *Queries) ListOutgoingConnections(ctx context.Context, arg *ListOutgoingConnectionsParams) ([]*ListOutgoingConnectionsRow, error) {
	rows, err := q.db.Query(ctx, listOutgoingConnections,
		arg.Limit,
		arg.SelfPeerID,
		arg.ContractStates,
		arg.PaginationCreatedAt,
		arg.PaginationGrantHash,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListOutgoingConnectionsRow{}
	for rows.Next() {
		var i ListOutgoingConnectionsRow
		if err := rows.Scan(
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ContentHash,
			&i.CreatedAt,
			&i.ValidNotAfter,
			&i.ValidNotBefore,
			&i.State,
			&i.Hash,
			&i.PublicKeyThumbprint,
			&i.OutwayPeerID,
			&i.ServicePublicationDelegatorPeerID,
			&i.DelegatorPeerID,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listOutgoingConnectionsForService = `-- name: ListOutgoingConnectionsForService :many
SELECT
    p.service_peer_id,
    p.service_name,
    p.content_hash,
    c.created_at,
    c.valid_not_after,
    c.valid_not_before,
    c.state,
    p.hash,
    p.public_key_thumbprint,
    $1::text as outway_peer_id,
    p.service_publication_delegator_peer_id,
    p.delegator_peer_id
FROM (
         SELECT  service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, null as delegator_peer_id, public_key_thumbprint
         FROM contracts.grants_service_connection
         WHERE outway_peer_id = $1::text AND grants_service_connection.service_name =  $2 AND  grants_service_connection.service_peer_id = $3 AND ($4::text IS NULL OR service_publication_delegator_peer_id = $4::text)
         UNION DISTINCT
         SELECT service_peer_id, service_name, content_hash, hash, service_publication_delegator_peer_id, delegator_peer_id as delegator_peer_id, public_key_thumbprint
         FROM contracts.grants_delegated_service_connection
         WHERE outway_peer_id = $1::text AND grants_delegated_service_connection.service_name = $2 AND  grants_delegated_service_connection.service_peer_id = $3 AND ($4::text IS NULL OR service_publication_delegator_peer_id = $4::text)
     ) AS p
         JOIN contracts.contracts_with_state AS c ON c.hash = p.content_hash
ORDER BY
CASE
    WHEN $5::text = 'asc' THEN  (c.created_at, p.hash COLLATE "C") END ASC,
CASE
    WHEN $5::text = 'desc' THEN (c.created_at, p.hash COLLATE "C") END DESC
`

type ListOutgoingConnectionsForServiceParams struct {
	SelfPeerID                        string
	ServiceName                       string
	ServicePeerID                     string
	ServicePublicationDelegatorPeerID pgtype.Text
	OrderDirection                    string
}

type ListOutgoingConnectionsForServiceRow struct {
	ServicePeerID                     string
	ServiceName                       string
	ContentHash                       string
	CreatedAt                         pgtype.Timestamptz
	ValidNotAfter                     pgtype.Timestamptz
	ValidNotBefore                    pgtype.Timestamptz
	State                             interface{}
	Hash                              string
	PublicKeyThumbprint               string
	OutwayPeerID                      string
	ServicePublicationDelegatorPeerID pgtype.Text
	DelegatorPeerID                   interface{}
}

// NOTE: unable to use ASC/DESC dynamically so we use a switch case
func (q *Queries) ListOutgoingConnectionsForService(ctx context.Context, arg *ListOutgoingConnectionsForServiceParams) ([]*ListOutgoingConnectionsForServiceRow, error) {
	rows, err := q.db.Query(ctx, listOutgoingConnectionsForService,
		arg.SelfPeerID,
		arg.ServiceName,
		arg.ServicePeerID,
		arg.ServicePublicationDelegatorPeerID,
		arg.OrderDirection,
	)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListOutgoingConnectionsForServiceRow{}
	for rows.Next() {
		var i ListOutgoingConnectionsForServiceRow
		if err := rows.Scan(
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ContentHash,
			&i.CreatedAt,
			&i.ValidNotAfter,
			&i.ValidNotBefore,
			&i.State,
			&i.Hash,
			&i.PublicKeyThumbprint,
			&i.OutwayPeerID,
			&i.ServicePublicationDelegatorPeerID,
			&i.DelegatorPeerID,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
